<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: src/CommsBehaviours.h Source File</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">CommsBehaviours.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_comms_behaviours_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef COMMS_BEHAVIOUR_h</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define COMMS_BEHAVIOUR_h</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;Arduino.h&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_behaviours_8h.html">Behaviours.h</a>&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_viz_blocks_8h.html">VizBlocks.h</a>&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="class_send_capabilities.html">   17</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_send_capabilities.html">SendCapabilities</a> : <span class="keyword">public</span> <a class="code" href="class_behaviour.html">Behaviour</a></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;{</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <a class="code" href="class_viz_block.html">VizBlock</a>* _node;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="class_send_capabilities.html#a3e831bc1f93dd960da4be93985c4afe8">   22</a></span>&#160;    <a class="code" href="class_send_capabilities.html#a3e831bc1f93dd960da4be93985c4afe8">SendCapabilities</a>(<a class="code" href="class_viz_block.html">VizBlock</a>* node, String <a class="code" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a> = <span class="stringliteral">&quot;SendCapabilities&quot;</span>);</div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="class_send_capabilities.html#a22f6f8ae27ebd478376f619629832ab5">   23</a></span>&#160;    String <a class="code" href="class_send_capabilities.html#a22f6f8ae27ebd478376f619629832ab5">start</a>(String <a class="code" href="class_behaviour.html#ad5aa6388bf5b47911ae801ebbf82e35d">args</a>);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;};</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="class_link.html">   34</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_link.html">Link</a> : <span class="keyword">public</span> <a class="code" href="class_behaviour.html">Behaviour</a></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;{</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <a class="code" href="class_viz_block.html">VizBlock</a>* _node;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    String _peerId;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">int</span> _timeoutInterval = 5000;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> _t = 0;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="class_link.html#a15f2732bd84cbd364ccdb8aaf310a7e5">   42</a></span>&#160;    <a class="code" href="class_link.html#a15f2732bd84cbd364ccdb8aaf310a7e5">Link</a>(<a class="code" href="class_viz_block.html">VizBlock</a>* node, String <a class="code" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a> = <span class="stringliteral">&quot;Link&quot;</span>);</div>
<div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="class_link.html#a6d9f3f3139b5325cefe19af730d9bc54">   43</a></span>&#160;    <span class="keywordtype">char</span>* <a class="code" href="class_link.html#a6d9f3f3139b5325cefe19af730d9bc54">args</a>();</div>
<div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="class_link.html#a758369a0b6dd6e9460a7883b83d8969f">   44</a></span>&#160;    String <a class="code" href="class_link.html#a758369a0b6dd6e9460a7883b83d8969f">start</a>(String <a class="code" href="class_link.html#a6d9f3f3139b5325cefe19af730d9bc54">args</a>);</div>
<div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="class_link.html#a4212a26ee2583b08e2307e7385b9a548">   45</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_link.html#a4212a26ee2583b08e2307e7385b9a548">update</a>();</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;};</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="class_ping_server.html">   53</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_ping_server.html">PingServer</a> : <span class="keyword">public</span> <a class="code" href="class_behaviour.html">Behaviour</a></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;{</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <a class="code" href="class_viz_block.html">VizBlock</a>* _node;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    String str;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">int</span> _interval = 4000;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> _t = 0;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="class_ping_server.html#aff2142bd5d823d613766f8a19b53a86f">   61</a></span>&#160;    <a class="code" href="class_ping_server.html#aff2142bd5d823d613766f8a19b53a86f">PingServer</a>(<a class="code" href="class_viz_block.html">VizBlock</a>* node, String <a class="code" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a> = <span class="stringliteral">&quot;PingServer&quot;</span>);</div>
<div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="class_ping_server.html#ae334bb0601762caaf90f9ff2d8f0f1d5">   62</a></span>&#160;    String <a class="code" href="class_ping_server.html#ae334bb0601762caaf90f9ff2d8f0f1d5">start</a>(String <a class="code" href="class_behaviour.html#ad5aa6388bf5b47911ae801ebbf82e35d">args</a>);</div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="class_ping_server.html#a40f0194de38762c74f405919283b2155">   63</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_ping_server.html#a40f0194de38762c74f405919283b2155">update</a>();</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160; </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;};</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="a_behaviours_8h_html"><div class="ttname"><a href="_behaviours_8h.html">Behaviours.h</a></div><div class="ttdoc">Functionality for block behaviours.</div></div>
<div class="ttc" id="a_viz_blocks_8h_html"><div class="ttname"><a href="_viz_blocks_8h.html">VizBlocks.h</a></div><div class="ttdoc">Contains everything you need to get started.</div></div>
<div class="ttc" id="aclass_behaviour_html"><div class="ttname"><a href="class_behaviour.html">Behaviour</a></div><div class="ttdoc">Parent class for all other behaviours.</div><div class="ttdef"><b>Definition:</b> Behaviours.h:20</div></div>
<div class="ttc" id="aclass_behaviour_html_a766009be6f0ed1acd74d4ba5c138a7bd"><div class="ttname"><a href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">Behaviour::name</a></div><div class="ttdeci">virtual String name()</div></div>
<div class="ttc" id="aclass_behaviour_html_ad5aa6388bf5b47911ae801ebbf82e35d"><div class="ttname"><a href="class_behaviour.html#ad5aa6388bf5b47911ae801ebbf82e35d">Behaviour::args</a></div><div class="ttdeci">virtual char * args()</div></div>
<div class="ttc" id="aclass_link_html"><div class="ttname"><a href="class_link.html">Link</a></div><div class="ttdoc">Experimental Behaviour leverages the ability to deliver commands over serial. If a block is connected...</div><div class="ttdef"><b>Definition:</b> CommsBehaviours.h:35</div></div>
<div class="ttc" id="aclass_link_html_a15f2732bd84cbd364ccdb8aaf310a7e5"><div class="ttname"><a href="class_link.html#a15f2732bd84cbd364ccdb8aaf310a7e5">Link::Link</a></div><div class="ttdeci">Link(VizBlock *node, String name=&quot;Link&quot;)</div></div>
<div class="ttc" id="aclass_link_html_a4212a26ee2583b08e2307e7385b9a548"><div class="ttname"><a href="class_link.html#a4212a26ee2583b08e2307e7385b9a548">Link::update</a></div><div class="ttdeci">void update()</div></div>
<div class="ttc" id="aclass_link_html_a6d9f3f3139b5325cefe19af730d9bc54"><div class="ttname"><a href="class_link.html#a6d9f3f3139b5325cefe19af730d9bc54">Link::args</a></div><div class="ttdeci">char * args()</div></div>
<div class="ttc" id="aclass_link_html_a758369a0b6dd6e9460a7883b83d8969f"><div class="ttname"><a href="class_link.html#a758369a0b6dd6e9460a7883b83d8969f">Link::start</a></div><div class="ttdeci">String start(String args)</div></div>
<div class="ttc" id="aclass_ping_server_html"><div class="ttname"><a href="class_ping_server.html">PingServer</a></div><div class="ttdoc">Experimental Behaviour that will regularly send a short message to the server so that the server know...</div><div class="ttdef"><b>Definition:</b> CommsBehaviours.h:54</div></div>
<div class="ttc" id="aclass_ping_server_html_a40f0194de38762c74f405919283b2155"><div class="ttname"><a href="class_ping_server.html#a40f0194de38762c74f405919283b2155">PingServer::update</a></div><div class="ttdeci">void update()</div></div>
<div class="ttc" id="aclass_ping_server_html_ae334bb0601762caaf90f9ff2d8f0f1d5"><div class="ttname"><a href="class_ping_server.html#ae334bb0601762caaf90f9ff2d8f0f1d5">PingServer::start</a></div><div class="ttdeci">String start(String args)</div></div>
<div class="ttc" id="aclass_ping_server_html_aff2142bd5d823d613766f8a19b53a86f"><div class="ttname"><a href="class_ping_server.html#aff2142bd5d823d613766f8a19b53a86f">PingServer::PingServer</a></div><div class="ttdeci">PingServer(VizBlock *node, String name=&quot;PingServer&quot;)</div></div>
<div class="ttc" id="aclass_send_capabilities_html"><div class="ttname"><a href="class_send_capabilities.html">SendCapabilities</a></div><div class="ttdoc">Behaviour that publishes a series of messages listing all the the block's abilities to the block's an...</div><div class="ttdef"><b>Definition:</b> CommsBehaviours.h:18</div></div>
<div class="ttc" id="aclass_send_capabilities_html_a22f6f8ae27ebd478376f619629832ab5"><div class="ttname"><a href="class_send_capabilities.html#a22f6f8ae27ebd478376f619629832ab5">SendCapabilities::start</a></div><div class="ttdeci">String start(String args)</div></div>
<div class="ttc" id="aclass_send_capabilities_html_a3e831bc1f93dd960da4be93985c4afe8"><div class="ttname"><a href="class_send_capabilities.html#a3e831bc1f93dd960da4be93985c4afe8">SendCapabilities::SendCapabilities</a></div><div class="ttdeci">SendCapabilities(VizBlock *node, String name=&quot;SendCapabilities&quot;)</div></div>
<div class="ttc" id="aclass_viz_block_html"><div class="ttname"><a href="class_viz_block.html">VizBlock</a></div><div class="ttdoc">The main VizBlock class.</div><div class="ttdef"><b>Definition:</b> VizBlocks.h:28</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
